import { ElementRef } from '@angular/core';
import { NgModel } from '@angular/forms';
export declare type CustomMaskConfig = {
    initialValue: string;
    currentCaretPosition: number;
};
export declare type CustomMaskResult = {
    maskedValue: string;
    newCaretPosition?: number;
};
export declare type CustomMask = (config: CustomMaskConfig) => CustomMaskResult;
export declare enum MaskType {
    LettersOnly = 0,
    NumbersOnly = 1,
    Alphanumeric = 2,
    Regex = 3,
    Custom = 4,
}
export declare class MaskingDirective {
    private ngModel;
    private inputElement;
    textMaskConfig: {
        type: MaskType;
        regex: any;
        custom: CustomMask;
    };
    constructor(inputElement: ElementRef, ngModel: NgModel);
    ngOnInit(): void;
    onInput(): void;
    isInt(value: any): boolean;
}
