(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@angular/common"), require("@angular/compiler"), require("@angular/core"), require("@angular/forms"));
	else if(typeof define === 'function' && define.amd)
		define("angular2-input-masks", ["@angular/common", "@angular/compiler", "@angular/core", "@angular/forms"], factory);
	else if(typeof exports === 'object')
		exports["angular2-input-masks"] = factory(require("@angular/common"), require("@angular/compiler"), require("@angular/core"), require("@angular/forms"));
	else
		root["angular2-input-masks"] = factory(root["@angular/common"], root["@angular/compiler"], root["@angular/core"], root["@angular/forms"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_4__, __WEBPACK_EXTERNAL_MODULE_0__, __WEBPACK_EXTERNAL_MODULE_2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.l = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// identity function for calling harmory imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };

/******/ 	// define getter function for harmory exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		Object.defineProperty(exports, name, {
/******/ 			configurable: false,
/******/ 			enumerable: true,
/******/ 			get: getter
/******/ 		});
/******/ 	};

/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};

/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 5);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_0__;

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

"use strict";
"use strict";
var core_1 = __webpack_require__(0);
var forms_1 = __webpack_require__(2);
(function (MaskType) {
    MaskType[MaskType["LettersOnly"] = 0] = "LettersOnly";
    MaskType[MaskType["NumbersOnly"] = 1] = "NumbersOnly";
    MaskType[MaskType["Alphanumeric"] = 2] = "Alphanumeric";
    MaskType[MaskType["Regex"] = 3] = "Regex";
    MaskType[MaskType["Custom"] = 4] = "Custom";
})(exports.MaskType || (exports.MaskType = {}));
var MaskType = exports.MaskType;
var MaskingDirective = (function () {
    function MaskingDirective(inputElement, ngModel) {
        this.ngModel = ngModel;
        this.textMaskConfig = {
            type: null,
            regex: null,
            custom: null,
        };
        this.inputElement = inputElement.nativeElement;
    }
    MaskingDirective.prototype.ngOnInit = function () {
        var _this = this;
        setTimeout(function () { return _this.onInput(); });
    };
    MaskingDirective.prototype.onInput = function () {
        var initialValue = this.inputElement.value;
        var caretPosition = this.inputElement.selectionStart;
        var mask;
        var regexMaskFactory = function (regex) {
            var c = function (config) {
                var replace = function (s) { return s.replace(regex, ''); };
                var textBeforeCaret = initialValue.slice(0, config.currentCaretPosition);
                var maskedValue = replace(config.initialValue);
                var newCaretPosition = replace(textBeforeCaret).length;
                var result = {
                    maskedValue: maskedValue,
                    newCaretPosition: newCaretPosition
                };
                return result;
            };
            return c;
        };
        switch (this.textMaskConfig.type) {
            case MaskType.LettersOnly:
                mask = regexMaskFactory(/[^a-z]/ig);
                break;
            case MaskType.NumbersOnly:
                mask = regexMaskFactory(/[^0-9.\-]/ig);
                break;
            case MaskType.Alphanumeric:
                mask = regexMaskFactory(/[^a-z0-9.\-]/ig);
                break;
            case MaskType.Regex:
                if (!this.textMaskConfig.regex) {
                    mask = null;
                    break;
                }
                mask = regexMaskFactory(this.textMaskConfig.regex);
                break;
            case MaskType.Custom:
                if (!this.textMaskConfig.custom) {
                    mask = null;
                    break;
                }
                mask = this.textMaskConfig.custom;
                break;
            default:
                mask = null;
        }
        var result = mask({ initialValue: initialValue, currentCaretPosition: caretPosition });
        if (result.maskedValue == initialValue)
            return;
        this.ngModel.control.updateValue(result.maskedValue, {
            onlySelf: false,
            emitEvent: true,
            emitModelToViewChange: true
        });
        if (this.isInt(result.newCaretPosition))
            this.inputElement.setSelectionRange(result.newCaretPosition, result.newCaretPosition);
    };
    MaskingDirective.prototype.isInt = function (value) {
        return !isNaN(value) && parseInt(Number(value)) == value && !isNaN(parseInt(value, 10));
    };
    __decorate([
        core_1.Input('textMask'), 
        __metadata('design:type', Object)
    ], MaskingDirective.prototype, "textMaskConfig", void 0);
    MaskingDirective = __decorate([
        core_1.Directive({
            selector: 'input[textMask]',
            host: {
                '(input)': 'onInput()'
            }
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, forms_1.NgModel])
    ], MaskingDirective);
    return MaskingDirective;
}());
exports.MaskingDirective = MaskingDirective;


/***/ },
/* 2 */
/***/ function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ },
/* 3 */
/***/ function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_3__;

/***/ },
/* 4 */
/***/ function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_4__;

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

"use strict";
"use strict";
__webpack_require__(0);
__webpack_require__(3);
__webpack_require__(4);
__webpack_require__(2);
var core_1 = __webpack_require__(0);
var masking_directive_1 = __webpack_require__(1);
var masking_directive_2 = __webpack_require__(1);
exports.MaskingDirective = masking_directive_2.MaskingDirective;
exports.MaskType = masking_directive_2.MaskType;
var MaskingModule = (function () {
    function MaskingModule() {
    }
    MaskingModule = __decorate([
        core_1.NgModule({
            declarations: [
                masking_directive_1.MaskingDirective
            ],
            exports: [
                masking_directive_1.MaskingDirective
            ],
            providers: []
        }), 
        __metadata('design:paramtypes', [])
    ], MaskingModule);
    return MaskingModule;
}());
exports.MaskingModule = MaskingModule;


/***/ }
/******/ ])
});
;